module Codeclimate
  module Collectors
    # The configuration for a collector client.
    # Used like a +Hash+. Treats all keys as symbols.
    class Configuration
      def initialize(attrs = {})
        @storage = attrs.deep_symbolize_keys
      end

      def [](key)
        storage[key.to_sym]
      end

      def []=(key, val)
        storage[key.to_sym] = val
      end

      def fetch(*args)
        case args.count
        when 1
          storage.fetch(args[0].to_sym)
        when 2
          storage.fetch(args[0].to_sym, args[1])
        else
          raise ArgumentError, "expected 1 or 2 arguments"
        end
      end

      private

      attr_reader :storage
    end
  end
end
