module Codeclimate
  module Collectors
    module Testing
      class StubMessagesFacade < MessagesFacade
        attr_reader :received_messages

        class NullMessagesImplementation
          def send_message(_msg); end
        end

        def initialize(implementation: NullMessagesImplementation.new)
          super

          @received_messages = []
        end

        def send_message(message)
          super
          received_messages << message
        end
      end
    end
  end
end

