module Codeclimate
  module Collectors
    module Validations
      class TypeValidator < ::ActiveModel::EachValidator
        def validate_each(record, attr_name, value)
          type = options.fetch(:type)
          if !value.nil? && !value.is_a?(type)
            record.errors.add(attr_name, "must be a #{type}")
          end
        end
      end
    end
  end
end
